\name{bk.prior}
\alias{bk.prior}
\title{Prior object for Bayesian Kriging}
\description{
  Contains one ore more sets of prior knowledge for Bayesian Kriging
}
\value{
  \item{namx,namy,namz,formula}{description of used regression model}
  \item{n}{number of priors in this object, length of each of the
    following lists}
  \item{mu}{list of prior guesses for regression parameter}
  \item{phi}{list of covariance matrices associated to \code{mu}}
  \item{phiinv}{list of invers matrices to \code{phi}}
  \item{type}{list containing type of prior knowledge
    (\code{"empirical"} or \code{"subjective"})}
  \item{lon,lat}{(\code{lon},\code{lat}) - location associated with prior,
    both are lists}
  \item{info}{list with additional info, see details.}
  \item{call}{list, recordings of calls generating each of the elements
    of this object}
}
\details{
  \code{info[[i]]} contains the size of additional dataset for
  \code{"empirical"} priors and the type of distribution for
  \code{"subjective"} priors.

  The inverse matrices \code{phiinv} are stored because they get often
  used later in the bk FORTRAN calls.
}
\references{
}
\seealso{
}
\author{}
\keyword{}